import java.lang.Math;
import java.util.LinkedList;
import java.awt.Color;

import jrobots.simulation.simulationObjects.JRobot2010;
import jrobots.utils.*;

/**
 * Ein minimaler funktionierender Bot, fertig zur Programmierung.
 * <p>
 * Vielleicht sollte er einen neuen Namen bekommen, wenn er auf sich was halten
 * k&ouml;nnen soll.
 */
public class AAABot extends JRobot2010 {
	private static final long serialVersionUID = 1L;
	private Angle scanWinkel;
	private Angle scanRichtung;
	private Angle OptWinkel;
	private int verloren;
	private int gefunden;
	private double entf;
	private boolean genau;
	private LinkedList<Scan> Scans = new LinkedList<Scan>();

	private int frame;
	private int letztergneauerframe;

	@Override
	protected void init() {
		verloren = 11;
		scanRichtung = new Angle(0, "d");
		scanWinkel = new Angle(90, "d");
		OptWinkel = ang(3);

	}

	@Override
	protected void actions() {
		/*if (frame % 2 == 0) {
			this.setNameColor(Color.white);
			this.setBodyColor(Color.black);
			this.setTurretColor(Color.black);
		} else {
			this.setNameColor(Color.black);
			this.setBodyColor(Color.white);
			this.setTurretColor(Color.white);
		}*/
		calibrate();

		collect();

		if (this.isScanFromNow()) {
			scan();
		}
		this.setScanAperture(scanWinkel);
		this.setScanDirection(scanRichtung);

		shoot();

		drive();
	}

	/**
	 * Vorbereitungen treffen
	 */
	private void calibrate() {

	}

	/**
	 * Sensoren auswerten
	 */
	private void collect() {
		if (!this.isScanFromNow()) {
			return;
		}
		if (Scans.size() > 4) {
			Scans.removeLast();
		}
	}

	/**
	 * Wohin soll der Scanner ausgerichtet werden?
	 */

	private void scan() {
		frame++;

		if (this.getLastScan().isTargetLocated()) {
			
			gefunden++;
			entf = getLastScan().distanceToTarget;
			OptWinkel = new Angle((int) this.getLastScan().distanceToTarget
					* (-.025) + 4, "d");

			if (verloren < 3) {// letzte Runde daneben
				genau = true;
				letztergneauerframe = frame;
				if(frame-letztergneauerframe>10){
					Scans.clear();
				}
				Scans.add(getLastScan());
				if (Scans.size()>4){
					Scans.removeLast();
				}

			}
			if (gefunden > 4) {
				if (gefunden > 7) {
					scanRichtung = scanRichtung.add(OptWinkel.mult(2));
				} else {
					scanRichtung = scanRichtung.add(OptWinkel.mult(1));
				}
				scanRichtung = scanRichtung.add(OptWinkel);
			}
			verloren = 0;
		} else {// gerade verloren
			verloren++;
			gefunden = 0;

			if (verloren > 2) {// verloren
				if (verloren > 10) {
					scanRichtung = scanRichtung.sub(ang(90));
					scanWinkel = this.getMaxScanAperture();

				} else {// 3-9x verloren
					scanRichtung = scanRichtung.sub(OptWinkel.mult(2));
				}

			} else {// Weniger als 3x verloren
				scanRichtung = scanRichtung.sub(OptWinkel);
			}
		}
		if (entf != 0) {
			int i = 1;
		}

		Vector mypos = getPosition();
		Vector Richtung = new Vector(
				Math.sin(scanRichtung.getValueAsDegrees()),
				Math.cos(scanRichtung.getValueAsDegrees()));
		Richtung = Richtung.mult(entf);
		this.addDebugArrow(mypos, Richtung.add(mypos));
	}

	/**
	 * Wohin soll geschossen werden?
	 */
	private boolean Mine;
private Angle dif;
	private void shoot() {
		/*if(Scans.size()>0){
			 dif=Scans.getLast().scanDirection.sub(Scans.get(Scans.size()-2).scanDirection).mult(-1.5);
			 System.out.println(dif);
		}else{
			dif=ang(0);
		}*/
	dif=ang(0);
		
		Angle SchussRichtung = scanRichtung.sub(scanWinkel.mult(0.5)).add(
				ang(3)).sub(dif);

		SchussRichtung.add(ang(frame % 4 - 2));
		if (frame % 200 == 0) {
			Mine = true;
		}

		this.setDropMineCommand(false);
		Mine = false;

		if (entf < 40) {
			if (entf < 30) {
				if (entf < 15) {// nah
					 this.setBodyColor(Color.blue);
					this.setLaunchProjectileCommand(scanRichtung.sub(ang(25)).add(dif));

				} else {// normal
						 this.setBodyColor(Color.red);
					this.setLaunchProjectileCommand(SchussRichtung.sub(ang(6)));

				}
			} else {// weit
					 this.setBodyColor(Color.black);
				this.setLaunchBulletCommand(SchussRichtung.sub(ang(8)));

			}
		} else {// sehr weit
				 this.setBodyColor(Color.red);
			this.setLaunchBulletCommand(SchussRichtung.add(ang((frame % 2 * (-2)+ 1)*2)).add(ang(-2)));
		}



	}

	/**
	 * Wohin f??hrt der JRobot?
	 */
	private int vor = 1;

	private int drehvor;
private int drehen ;

private void drive() {
	if (entf <15) {
		vor = -1;
		drehen = 20;
	} else {
		if (frame % 100 > 70) {
			vor = -1;
			drehen = 70;
		} else {
			vor = 1;
			drehen = -10;
		}
	}
	if(frame%60>30){
		drehvor=-1;
		
	}else{
		drehvor=1;
	}
	if (vor == -1) {
		if(drehvor==-1){
			this.setAutopilot(
					scanRichtung.sub(ang(drehen*drehvor )),
					vor);
		}else{
		this.setAutopilot(
				scanRichtung.sub(scanWinkel.mult(0.5)).add(ang(drehen*drehvor )),
				vor);}
	} else {
		this.setAutopilot(scanRichtung.sub(scanWinkel.mult(0.5)).add(ang(drehen*drehvor)),
				vor);
	}

}

	private Angle ang(int Winkel) {
		return new Angle(Winkel, "d");
	}

}
