import java.lang.Math;
import java.awt.Color;

import jrobots.simulation.simulationObjects.JRobot2010;
import jrobots.utils.*;

/** Ein minimaler funktionierender Bot, fertig zur Programmierung. 
 * <p>Vielleicht sollte er einen neuen Namen bekommen, wenn er auf sich was 
 * halten k&ouml;nnen soll. 
 */
public class Botty extends JRobot2010 {
    private static final long serialVersionUID = 1L;
    
    private Angle lastScanDir = new Angle(0, "d");
    private Angle lastScanAperture =  new Angle(90, "d");
    
    private Angle scanDir;
    private Angle ScanAperture;
    
    private Scan[] lastScan = new Scan[5];
    private Boolean[] ScansSuccessful = new Boolean[5];
    
    private Scan[] enemyPosition = new Scan[5];
    
    //private int ScanState = 0;
    
    private int roundScan = 0;
    
    private int looseScansRow = 4;
    //private int preziceScansRow = 0;
    
    private Scan latestScan;
    
    private Angle searchBase = new Angle(0, "d");
    

    @Override
    protected void init() {
        
        setNameColor(new Color((float)1.0,(float)0.0,(float)0.0));
        this.setBodyColor(new Color((float)0.0,(float)0.0,(float)0.0));
        this.setTurretColor(new Color((float)0.0,(float)1.0,(float)0.5));
        //setAutopilot(getOrientation(), 1.0);
        ScanAperture = getMaxScanAperture();
        scanDir = getOrientation();
        setScanAperture(ScanAperture);
        setScanDirection(scanDir);
        

        //Default Werte setzten
        for (int i = 0; i < 5; i++) {
        	ScansSuccessful[i] = new Boolean(false);
        	
        	lastScan[i] = new Scan(
                    RIGHT, 
                    new Angle(360, "d"),
                    Double.MAX_VALUE,
                    this.getPosition(),
                    0.0);
        	
        	enemyPosition[i] = lastScan[i];
        }

    	
    }
    
    @Override
    protected void actions() {
        calibrate();
        
        collect();
        
        if (this.lastScan[0].timeOfScan + this.getScanInterval() <= this.getTime())
        {scan();}
        
        shoot();
        
        drive();
    }
        
    /** 
     * Vorbereitungen treffen 
     */
    private void calibrate() {

    }    
    
    /**
     * Sensoren auswerten
     */
    private void collect() {
    	
    	//letzten Scanwert abholen
    	latestScan = this.getLastScan();

    }
    
    /**
     * Wohin soll der Scanner ausgerichtet werden?
     */
    private void scan() {
    	
    	if (this.isScanFromNow() == true) {	//wenn der Wert neu ist
    		// Verlauf aktualisieren
	    	for (int i = 4; i > 0; i--) {
	    		ScansSuccessful[i] = ScansSuccessful[i-1];
	    		lastScan[i] = lastScan[i-1];
	    	}
	
	    	//Wenn das Ziel gefunden wurde
	    	if (latestScan.isTargetLocated() == true) {
	    		
	    		//neue Werte in den Verlauf schreiben
	    		lastScan[0] = latestScan;
	    		ScansSuccessful[0] = true;
	    		
	    		looseScansRow = 0;
	    		
	    		scanDir = lastScanDir;
	
	    		ScanAperture = lastScanAperture.sub(new Angle(30, "d"));
	    		
	    		if (lastScanAperture.getValueAsDegrees() == 6) {
	    			
	    			
	    		}
	
	    		// letzten Gegnerpositionen festhalten
	    		for (int i = 4; i > 0; i--) {
	        		enemyPosition[i] = enemyPosition[i-1];
	        	}
	    		enemyPosition[0] = latestScan;
	    		
	    		//ffnungswinkel auf 6 beschrnken
	    		if (ScanAperture.getValueAsDegrees() < 6) {
	    			ScanAperture = new Angle(6, "d");
	    			if (enemyPosition[0].distanceToTarget >= 50) {
	    				ScanAperture = new Angle(4, "d");
	    			}
	    		}
	    		searchBase = lastScanDir;
	    	
		    //Wenn das Ziel gefunden wurde
	    	} else {
	
	    		lastScan[0] = latestScan;
	    		ScansSuccessful[0] = false;
	    		
	    		looseScansRow++;
	    		
	    		//neuer Rundumscan, wenn mehr als 4 mal danebengescannt wurde
	    		if (looseScansRow > 4 ) {
	    			ScanAperture = new Angle(60, "d");
	    			scanDir = new Angle(((roundScan % 6) * 60),"d");
	    			roundScan++;
	    		
	    		//letzten Bereich absuchen
	    		} else {
	    			
	    			if (ScansSuccessful[0] == false) {
	    				
	    				ScanAperture = new Angle(16,"d");
	    				scanDir = searchBase.sub(new Angle(24,"d"));
	    				
	    				if (ScansSuccessful[1] == false) {
	    					
	    					scanDir = searchBase.sub(new Angle(8,"d"));
	    					
	    	    			if (ScansSuccessful[2] == false) {
	    	    				
	    	    				scanDir = searchBase.add(new Angle(8,"d")); 
	    	    				
	    	    				if (ScansSuccessful[3] == false) {
	    	    					
	    		    				scanDir = searchBase.add(new Angle(24,"d")); 
	    	    					
	    	    				}
	    	    			}
	    				}
	    			}
	    		}
	    	}
	
	    	lastScanDir = scanDir;
	    	lastScanAperture = ScanAperture;
    	}	
    	
    	//Scanner ausrichten
    	this.setScanAperture(ScanAperture);
    	this.setScanDirection(scanDir);
    
    	
    }
    
    /**
     * Wohin soll geschossen werden?
     */
    private void shoot() {

    	//Ist der Gegner weniger als 50m vom Bot entfernt, soll mit schweren Geschossen geschossen werden
    	if (enemyPosition[0].distanceToTarget > 50) {
    	
    		this.setLaunchBulletCommand(enemyPosition[0].scanDirection);
    		
    		
    	//ansonsten sollen leichte Geschosse verwendet werden
    	} else {
    		this.setLaunchProjectileCommand(enemyPosition[0].scanDirection);
    	}
    	
    	//Wenn mglich soll eine Panzersperre gelegt werden
    	this.setDropTankTrapCommand(true);
    	
    	/**
    	Vector[] debug = new Vector[2];
    	debug[0] = enemyPosition[0].estimatedTargetPosition();
    	debug[1] = this.getPosition();
    	
    	this.setDebugLines(debug);
    	**/
    }
    
    /**
     * Wohin f??hrt der JRobot?
     */
    private void drive() {
        
    	//Wenn der Bot mehr als 40m von seinem Gegner entfernt ist, soll er auf ihn zufahren
    	if (enemyPosition[0].distanceToTarget > 40) {
    		
    		this.setAutopilot(enemyPosition[0].scanDirection, 1.0);
    		
    	} 
    	//Wenn der Gegner nicht wahrgenommen wurde, soll der Bot weiter in die letzte Richtung fahren
    	
    }
    
    




}
