import java.awt.Color;
import java.util.Random;

import jrobots.simulation.simulationObjects.JRobot2010;
import jrobots.utils.Angle;
import jrobots.utils.LinearPredictor;
import jrobots.utils.Scan;
import jrobots.utils.Vector;

public class CptKirk extends JRobot2010
{
	private static final long	serialVersionUID				= 1L;
	Angle											autopilotMomentum;
	private int								counterScan							= 2;
	private int								bulletCounter						= 0;
	private double						letzterTreffer					= -45.0;
	private boolean						targetLocated						= false;
	private boolean						targetFirstLocated			= false;
	private boolean						targetFirstTestLocated	= false;
	private double						scanSensitivityTest			= 15.0;
	private Scan							scan1										= null;
	private Scan							scan2										= null;
	private Scan							letzterTrefferScan			= null;
	private boolean						scan1WasJustSet					= false;
	private boolean						bulletStrikeToLeft			= true;
	private double						bulletTime1							= 0.0;
	private double						bulletTime2							= 0.0;
	private Random						randomM									= new Random();
	private int								richtung								= 1;
	private boolean						richtungGesetzt;
	private int								zufall;
	private int								scanVersucheNachRechts	= 0;
	private int								scanVersucheNachLinks		= 0;
	private int								scanVersucheLinksRechts	= 0;
	private int								flag										= 1;

	@Override
	protected void init()
	{

	}

	@Override
	protected void actions()
	{
		calibrate();

		collect();

		scan();

		shoot();

		drive();
	}

	private void calibrate()
	{
		if (scan2 != null && scan2.distanceToTarget < 30.0)
		{
			setDropMineCommand(true);
		}
	}

	private void collect()
	{

	}

	private void scan()
	{
		Scan letzterScan = this.getLastScan();

		double letzterScanDirection = (letzterScan.scanDirection.angle) * 180.0 / Math.PI;

	// Standard-Suche nach Rechts (erster Durchlauf)
		println("Standard-Suche nach rechts (erster Durchlauf)");
		setScanDirection(new Angle(letzterScanDirection + scanSensitivityTest, "Degrees"));
		setScanAperture(new Angle(scanSensitivityTest, "Degrees"));
		
		
		if (letzterScan.isTargetLocated() == true)
		{
			letzterTreffer = letzterScanDirection;
			letzterTrefferScan = letzterScan;

			// // scan2 ist immer der neuere
			scan1 = scan2;
			scan2 = getLastScan();

			targetFirstLocated = true;
			targetFirstTestLocated = true;
			targetLocated = true;
			println("Ziel wurde gefunden!");
			scanVersucheLinksRechts = 0;
			scanVersucheNachLinks = 0;
			scanVersucheNachRechts = 0;
		}

		if (letzterScan.isTargetLocated() == false)
		{
			if (targetFirstTestLocated == true)
			{
				if (scanVersucheNachRechts < 2)
				{
					// Standard-Suche nach Rechts
					println("Standard-Suche nach rechts");
					setScanDirection(new Angle(letzterScanDirection + scanSensitivityTest, "Degrees"));
					setScanAperture(new Angle(scanSensitivityTest, "Degrees"));
					if (isScanFromNow() == true)
					{
						scanVersucheNachRechts++;
						scanVersucheLinksRechts++;
						// scanVersucheNachLinks = 0;
						println("scanVersucheNachRechts: " + scanVersucheNachRechts);
						println("scanVersucheNachLinks: " + scanVersucheNachLinks);
					}
				}
				else if (scanVersucheNachLinks < 10)
				{
					println("Standard-Suche nach links");
					// Standard-Suche nach Links
					setScanDirection(new Angle(letzterScanDirection - scanSensitivityTest, "Degrees"));
					setScanAperture(new Angle(scanSensitivityTest, "Degrees"));
					if (isScanFromNow() == true)
					{
						scanVersucheNachLinks++;
						scanVersucheLinksRechts++;
						// scanVersucheNachRechts = 0;
						println("scanVersucheNachRechts: " + scanVersucheNachRechts);
						println("scanVersucheNachLinks: " + scanVersucheNachLinks);
					}
				}
			}
			else
			{
				// Standard-Suche nach Rechts (erster Durchlauf)
				println("Standard-Suche nach rechts (erster Durchlauf)");
				setScanDirection(new Angle(letzterScanDirection + scanSensitivityTest, "Degrees"));
				setScanAperture(new Angle(scanSensitivityTest, "Degrees"));
			}
		}
		else
		{
			setScanDirection(new Angle(letzterScanDirection, "Degrees"));
			setScanAperture(new Angle(scanSensitivityTest, "Degrees"));
		}
		if (scanVersucheLinksRechts > 20)
		{
			scanVersucheLinksRechts = 0;
			targetFirstTestLocated = false;
		}
		if (letzterTrefferScan != null)
		{
			if (letzterTrefferScan.distanceToTarget <= 10)
			{
				scanSensitivityTest = 36.0;
				println("ffnungswinkel auf 36 gesetzt (Distanz <= 10)");
			}
			else if (letzterTrefferScan.distanceToTarget <= 30)
			{
				scanSensitivityTest = 18.0;
				println("ffnungswinkel auf 18 gesetzt (Distanz <= 30)");
			}
			else if (letzterTrefferScan.distanceToTarget <= 50)
			{
				scanSensitivityTest = 9.0;
				println("ffnungswinkel auf 9 gesetzt (Distanz <= 50)");
			}
			else if (letzterTrefferScan.distanceToTarget <= 70)
			{
				scanSensitivityTest = 5.0;
				println("ffnungswinkel auf 5 gesetzt (Distanz <= 70)");
			}
			else
			{
				scanSensitivityTest = 3.5;
				println("ffnungswinkel auf 3.5 gesetzt (Distanz > 70)");
			}

		}
	}

	private void println(String s)
	{
		System.out.println(this.getTime() + " : " + s);
	}

	private void shoot()
	{
		double time = this.getTime();
		if (scan1 != null)
		{

			if (scan2.distanceToTarget <= 40.0)
			{

				time = calculateTimeofHitProjectile(scan2.distanceToTarget);
				Vector v = LinearPredictor.predict(scan1, scan2, time);
				addDebugCrosshair(v);
				setLaunchProjectileCommand(new Angle(calculateAngleFromVector(v), "Degrees"));
			}
			else if (scan2.distanceToTarget >= 80.0)
			{

				time = calculateTimeofHitMissile(scan2.distanceToTarget);
				Vector v = scan2.estimatedTargetPosition().add(LinearPredictor.predict(scan1, scan2, time)).mult(0.5);
				addDebugCrosshair(v);
				setLaunchMissileCommand(new Angle(calculateAngleFromVector(v), "Degrees"));
				setMissileTarget(v);
			}
			else
			{
				double nextBulletDirection, leftScanEdge, rightScanEdge;
				time = calculateTimeofHitBullet(scan2.distanceToTarget);
				Vector v = LinearPredictor.predict(scan1, scan2, time);
				addDebugCrosshair(v);
				nextBulletDirection = calculateAngleFromVector(v) + bulletCounter;

				leftScanEdge = calculateAngleFromVector(v) - scan2.scanAperture.getValueAsDegrees();
				rightScanEdge = calculateAngleFromVector(v) - scan2.scanAperture.getValueAsDegrees();

				setLaunchBulletCommand(new Angle(nextBulletDirection, "Degrees"));

				println("nextBulletDirection: " + nextBulletDirection);

				bulletTime2 = this.getTime();

				if (bulletStrikeToLeft == true)
				{
					if (nextBulletDirection > leftScanEdge)
					{
						println("bulletCounter wird gesenkt, bulletCounter: " + bulletCounter);
						bulletCounter = bulletCounter - 1;
					}
					else
					{
						bulletStrikeToLeft = false;
					}
				}
				else
				{
					if (nextBulletDirection < rightScanEdge)
					{
						println("bulletCounter wird erhht, bulletCounter: " + bulletCounter);
						bulletCounter = bulletCounter + 1;
					}
					else
					{
						bulletStrikeToLeft = true;
					}
				}

				bulletTime1 = this.getTime();

			}
		}
		else
		{
			setLaunchProjectileCommand(new Angle(letzterTreffer, "Degrees"));
		}
	}

	private double calculateAngleFromVector(Vector v)
	{
		Vector pos = this.getPosition();

		double posX, posY, vX, vY, difX, difY, angle;

		posX = pos.getX();
		posY = pos.getY();
		vX = v.getX();
		vY = v.getY();

		difX = (posX - vX);
		difY = (posY - vY);

		angle = difY / difX;

		angle = Math.atan(angle);

		angle = angle * 180.0 / Math.PI;

		if (vX > posX)
		// Ziel befindet sich im 1. oder 2. Quadranten(rechts)
		{
			// angle = angle;
		}
		else if (vX < posX)
		// Ziel befindet sich im 3. oder 4. Quadranten(links)
		{
			angle = angle + 180.0;
		}

		System.out.println("Waffe wird ausgerichtet: " + angle);

		return angle;
	}

	private double calculateTimeofHitProjectile(double entfernungZumZiel)
	{

		double speed = getProjectileSpeed(); // meter/s

		double flugdauer = entfernungZumZiel / speed;

		return this.getTime() + flugdauer;
	}

	private double calculateTimeofHitBullet(double entfernungZumZiel)
	{

		double speed = getBulletSpeed(); // meter/s

		double flugdauer = entfernungZumZiel / speed;

		return this.getTime() + flugdauer;
	}

	private double calculateTimeofHitMissile(double entfernungZumZiel)
	{

		double speed = getMissileSpeedMax(); // meter/s

		double flugdauer = entfernungZumZiel / speed;

		return this.getTime() + flugdauer;
	}

	private void drive()
	{
		double time = this.getTime();
		if (scan2 != null)
		{
			if (scan2.distanceToTarget > 45.0)
			{

				if (((int) time) % 3 == 0)
				{
					flag *= -1;

					setBodyColor(new Color(new Random().nextInt(255), new Random().nextInt(255), new Random().nextInt(255)));
					setTurretColor(new Color(new Random().nextInt(255), new Random().nextInt(255), new Random().nextInt(255)));

					setAutopilot(new Angle(scan2.scanDirection.getValueAsDegrees() + (70 * flag), "Degrees").normalize(), 1.0);
				}

			}
			else
			{

				double letzterScanDirection = scan2.scanDirection.getValueAsDegrees();

				int zufallSpeed = randomM.nextInt(2);
				int zufallDrive = randomM.nextInt(30) + 28;
				if (zufall == 1)
				{
					zufallDrive = zufallDrive * (-1);
				}

				// if (zufall == 1 && richtung != 1)
				// richtung = richtung * (-1);
				// if (zufall != 1)
				// richtung = -1;
				// if (scan1 != null && scan2 != null) {
				// if ((!scan1.isTargetLocated())
				// && (!scan2.isTargetLocated()))
				// richtung = 1;
				// }
				if (scan2.isTargetLocated())
				{
					// counterScan = -1;
					if (zufallSpeed == 1)
					{
						setAutopilot(new Angle(letzterScanDirection + zufallDrive, "Degrees"), 1.0);
					}
					else
					{
						setAutopilot(new Angle(letzterScanDirection + zufallDrive, "Degrees"), 0.7);
					}
				}

			}
		}
		else
		{
			setAutopilot(new Angle(randomM.nextInt(360), "Degrees"), 1.0);
		}
	}
}
