import java.lang.Math;
import java.util.LinkedList;
import java.awt.Color;

import jrobots.simulation.simulationObjects.JRobot2010;
import jrobots.utils.*;

/**
 * Ein minimaler funktionierender Bot, fertig zur Programmierung.
 * <p>
 * Vielleicht sollte er einen neuen Namen bekommen, wenn er auf sich was halten
 * k&ouml;nnen soll.
 */
public class Hector extends JRobot2010 {
	private static final long serialVersionUID = 1L;
	private Angle scanAperture; // momentary scanAperture, needed in next frame
	private Angle scanDirection; // momentary scanDirection, needed in next
									// frame
	private Scan latestSuccessfulScan; // last scanned target
	private int scanState;
	private int scan_ROUNDABOUT_COUNT;
	int i = 360, a = 1, b = 0, c = 1, d = 0, m = 0, q = 1, w = 1, y = 0, s = 1;
	private Angle lastDirection;
	// private Scan later;
	private Vector expectedPosition;
	private Scan lastPosition1, lastPosition2;

	private LinkedList<Scan> scans = new LinkedList<Scan>();

	
	private Vector newPosition;
	@Override
	protected void init() {
		setNameColor(new Color((float) 0.0, (float) 0.0, (float) 0.0));
		setAutopilot(getOrientation(), 1.0);
		scanAperture = getMaxScanAperture();
		scanDirection = getOrientation();
		setScanAperture(scanAperture);
		setScanDirection(scanDirection);
		latestSuccessfulScan = new Scan(RIGHT, new Angle(180, "d"),
				Double.MAX_VALUE, this.getPosition(), Double.NEGATIVE_INFINITY);
	}

	@Override
	protected void actions() {
		calibrate();

		collect();

		scan();

		shoot();

		drive();
	}

	/**
	 * Vorbereitungen treffen
	 */
	private void calibrate() {
		if (a == 0) {
			scan_ROUNDABOUT_COUNT = 5;
		} else {
			scan_ROUNDABOUT_COUNT = 18;

		}// Math.max(3,
			// (int)Math.ceil(360.0 /
			// getMaxScanAperture().getValueAsDegrees()));
	}

	private double lastTimeFound, timeUp;
	private final double MAX_ROUND_DELAY = 0.5;
	private final double MAX_DIRECTION = 4;

	/**
	 * Sensoren auswerten
	 */
	private void collect() {
		if (scans.size() > 1) {
		this.addDebugCrosshair(scans.getFirst().estimatedTargetPosition());
		this.addDebugCrosshair(scans.getLast().estimatedTargetPosition());
		}
		
		// Scanner nur auswerten, wenn gerade gescannt wurde
		if (isScanFromNow()) {
			if (this.getLastScan().isTargetLocated()) {
				lastTimeFound = getTime();

				a = 0;
				latestSuccessfulScan = this.getLastScan();
				
				if (scans.size() > 1) {
					if (latestSuccessfulScan.timeOfScan - scans.getLast().timeOfScan > 0.5)
						scans.add(latestSuccessfulScan);
				} else {
					scans.add(latestSuccessfulScan);
				}


				if (scans.size() > 2)
					scans.removeFirst();

				// later=latestSuccessfulScan;
				lastDirection = latestSuccessfulScan.scanDirection;
				// lastDirection = lastDirection.sub(new Angle(10 * b,
				// "Degrees"));
				b = 0;

				if (c == 1) {
					// if(((lastPosition1.scanDirection.sub(lastPosition2.scanDirection))).isPositive())
					// {
					// setLaunchProjectileCommand(latestSuccessfulScan.scanDirection);//.add(new
					// Angle(10,"Degrees")));//lastPosition2.scanDirection.add(new
					// Angle(10,"Degrees")));
					// }
					// setLaunchMissileCommand(latestSuccessfulScan.scanDirection);
					// setMissileTarget(expectedPosition);
				} else {
					// setLaunchProjectileCommand(expectedPosition)
					// setLaunchProjectileCommand(latestSuccessfulScan.scanDirection);//.sub(new
					// Angle(10,"Degrees")));//lastPosition2.scanDirection.add(new
					// Angle(10,"Degrees")));
					// setMissileTarget(expectedPosition);

				}

			} else {
				c++;
				c = c % 2;

				if ((getTime() - lastTimeFound) > MAX_ROUND_DELAY) {
					a = 1;
				}

				// sc
				// scanDirection = latestSuccessfulScan.scanDirection.sub(new
				// Angle(25,"Degrees"));

				b++;
				// setLaunchProjectileCommand(latestSuccessfulScan.scanDirection.add(new
				// Angle(10,"Degrees")));
			}

		}
	}

	/**
	 * Wohin soll der Scanner ausgerichtet werden?
	 */
	private void scan() {

		// Scanner neu ausrichten, wenn gerade gescannt wurde
		if (isScanFromNow()) {
			// 360 Grad scannen

			if (scans.size() == 2) {
				expectedPosition = LinearPredictor.predict(scans.getFirst(),
						scans.getLast(), scans.getLast().timeOfScan +0.5+ (scans.getLast()).distanceToTarget/getProjectileSpeed());
				newPosition=expectedPosition.sub(getPosition());
				setLaunchProjectileCommand(newPosition.getAngle());
				this.addDebugCrosshair(expectedPosition);				
			}
			// naechster Scannerzustand
			scanState++;
			// wegen modulo gibt's keinen Ueberlauf

			scanState = scanState % scan_ROUNDABOUT_COUNT;
			// maximaler Oeffnungswinkel
			// scanAperture = new Angle(40,"Degrees");//getMaxScanAperture();
			// Scanrichtung: #Scan * (360 Grad / gesamtanzahl_scans)
			if (a == 0) {
				// a=1;

				scanAperture = new Angle(15, "Degrees");
				scan_ROUNDABOUT_COUNT = 2;
				// latestSuccessfulScan = this.getLastScan();
				
				if (c == 0) {
					scanDirection = lastDirection.add(new Angle(2.5, "Degrees"));
					if (this.getLastScan().isTargetLocated()) {
						//setLaunchProjectileCommand(newPosition.getAngle());//scanDirection.sub(new Angle(
								//5, "Degrees")));// lastPosition2.scanDirection.add(new
												// Angle(10,"Degrees")));
					}

				} else {
					scanDirection = lastDirection.sub(new Angle(2.5, "Degrees"));
					if (this.getLastScan().isTargetLocated()) {
						//setLaunchProjectileCommand(scanDirection.add(new Angle(
								//5, "Degrees")));// lastPosition2.scanDirection.add(new
												// Angle(10,"Degrees")));
					}
				}
			} else {
				scanAperture = new Angle(20, "Degrees");
				scan_ROUNDABOUT_COUNT = 18;
				scanDirection = (new Angle(360, "Degrees"))
						.mult((double) scanState / scan_ROUNDABOUT_COUNT);
			}
			// Oeffnungswinkel und Scanrichtung an Scanner durchgeben
		}
		// Wenn noch nicht gescannt wurde, zur Sicherheit nochmal Befehl setzen
		setScanAperture(scanAperture);
		setScanDirection(scanDirection);
	}

	/**
	 * Wohin soll geschossen werden?
	 */
	private void shoot() {
		if (lastDirection == latestSuccessfulScan.scanDirection) {
			lastDirection = latestSuccessfulScan.scanDirection;
			// setLaunchProjectileCommand(latestSuccessfulScan.scanDirection);
		}
	}

	/**
	 * Wohin f??hrt der JRobot?
	 */
	private void drive() {
		// setAutopilot(latestSuccessfulScan.scanDirection, 1.0);
		// setAutopilot(new Angle(0,"Degrees"),1.0);
		if (a == 0) {

			// if (d == 1) {
			// d = 0;
			// lastDirection.add(new Angle(60, "Degrees"));
			// }

			// else
			// {
			// q=1;
			// }
			/*
			 * if(w==1) { timeUp=getTime(); w=0; }
			 */
			if (getHealth() < 0.5) {
				s = -1;
			}

			if (q == 100 || y == 1) {
				setAutopilot(latestSuccessfulScan.scanDirection.add(new Angle(
						45, "Degrees")), s);
				q--;

				if (q == 0) {
					y = 0;
				}
			} else {
				setAutopilot(latestSuccessfulScan.scanDirection.sub(new Angle(
						45, "Degrees")), s);
				q++;
				if (q == 100) {
					y = 1;
				}
			}
			/*
			 * if((getTime()-timeUp)>5) { w=1;
			 * 
			 * q=0; } else { q=1; }
			 */
		}
	}

}
