import java.lang.Math;
import java.awt.Color;

import jrobots.simulation.simulationObjects.JRobot2010;
import jrobots.utils.*;

/** Ein minimaler funktionierender Bot, fertig zur Programmierung. 
 * <p>Vielleicht sollte er einen neuen Namen bekommen, wenn er auf sich was 
 * halten k&ouml;nnen soll. 
 */
public class KommunistischesKaenguru extends JRobot2010 {

    private Angle scanAperture; //momentary scanAperture, needed in next frame 
    private Angle scanDirection;
    public Angle normalize;//momentary scanDirection, needed in next frame 
    private Scan latestSuccessfulScan;
    private Scan oldScan;//last scanned target
    private double firstSuccessfulScan;
    private int scanState;
    private int scan_ROUNDABOUT_COUNT;
    public double distanceToTarget;
    public double getArcLength;
    private double aperture=23;
    private int scan;
    private boolean mine;
    
    private static final long serialVersionUID = 1L;

   
    
    @Override
    protected void actions() {
        calibrate();
        
        collect();
        
        scan();
        
        shoot();
        
        drive();
    }
        
    /** 
     * Vorbereitungen treffen 
     */
    private void calibrate() {

    	scan_ROUNDABOUT_COUNT=4;
    }    
    
    /**
     * Sensoren auswerten
     */
    private void collect() {
    	    	
    	if (this.isScanFromNow())
    	{
    		
    		if (this.getLastScan().isTargetLocated())
    		{
    			oldScan=latestSuccessfulScan;
    			latestSuccessfulScan=this.getLastScan();
    		}    
    	else
    	{
    		firstSuccessfulScan=getTime();
    	}
    	}
    }
    
    /**
     * Wohin soll der Scanner ausgerichtet werden?
     */
    private void scan() {
    	
    	if (isScanFromNow()) {
    		//if (firstSuccessfulScan!=0)
    			
    		{
        double diff = getTime() - latestSuccessfulScan.timeOfScan;  
        double timeDiff = latestSuccessfulScan.timeOfScan -
        		firstSuccessfulScan;
        
    	if (diff<0.5 && timeDiff<0.5)
    	{
    		scan=2;
    	}
    	if (diff<1.0 && timeDiff<1.0)
    	{
    		scan=3;
    	}
    	else
    	{
    		scan=20;
    	}
        if (this.getLastScan().getArcLength()==0)
        {
        	scanDirection=scanDirection.add(new Angle(scan, "d"));        	
                                
        } 
        else {
        	scanDirection=scanDirection.sub(new Angle(scan, "Degrees"));        	
        }
        setScanAperture(scanAperture);
        setScanDirection(scanDirection);
        
    		}
    	}
        else {
            // Wenn noch nicht gescannt wurde, zur Sicherheit nochmal Befehl setzen
            setScanAperture(scanAperture);
            setScanDirection(scanDirection);
        	}
    	
    }
    
    /**
     * Wohin soll geschossen werden?
     */
    private void shoot() {
    //	if (!(oldScan==null||latestSuccessfulScan==null))
    			{
    //	Vector v=latestSuccessfulScan.estimatedTargetPosition();
    	//double time=v.getLength()/JRobot2010.getProjectileSpeed();
    	//Vector newPosition=LinearPredictor.predict(oldScan,latestSuccessfulScan,
    		//	this.getTime() + time);
   // setLaunchProjectileCommand(newPosition.getAngle().getOpposite());
    			}
    	//distanceToTarget=latestSuccessfulScan();
    	if (distanceToTarget>20 && distanceToTarget<60)
    	{
    		this.setDropMineCommand(true); 
    	}		
    			
    	Vector pos = latestSuccessfulScan.estimatedTargetPosition();
    	distanceToTarget=this.getPosition().distanceTo(pos);
    	
    	double diff = getTime() - latestSuccessfulScan.timeOfScan;  
        double timeDiff = latestSuccessfulScan.timeOfScan -
        		firstSuccessfulScan;
    	
    	if (distanceToTarget>40)
    	{
    		if (diff>0.08)
    		{
    			if (diff>0.3)
    			{
    			setLaunchBulletCommand(scanDirection.add(new Angle (aperture/2+8, "d")));
    			}
    			else
    			{
    			setLaunchBulletCommand(scanDirection.add(new Angle (aperture/2+5, "d")));	
    			}
    		}
    		else {
    		if (timeDiff>0.08)
    		{
    			if (timeDiff>0.3)
    			{
    			setLaunchBulletCommand(scanDirection.add(new Angle (aperture/2-8, "d")));
    			}
    			else
    			{
    				setLaunchBulletCommand(scanDirection.add(new Angle (aperture/2-5, "d")));
    			}
    		}
    		else
    		{
        		setLaunchBulletCommand(scanDirection.add(new Angle (aperture/2, "d")));	
        	}
    		}
    	}
    	else 
    	{
    		if (diff>0.3)
    		{
    			setLaunchProjectileCommand(scanDirection.add(new Angle (aperture/2+8, "d")));	
    		}
    		if (timeDiff>0.3)
    		{
    			setLaunchProjectileCommand(scanDirection.add(new Angle (aperture/2-8, "d")));	
    		}
    		else
    		{
        		setLaunchProjectileCommand(scanDirection.add(new Angle (aperture/2, "d")));	
        	}
    	}
    }
    
    /**
     * Wohin f??hrt der JRobot?
     */
    private void drive() {
    	//distanceToTarget=latestSuccessfulScan.estimatedTargetPosition().getLength();
    	Vector pos = latestSuccessfulScan.estimatedTargetPosition();
    	distanceToTarget=this.getPosition().distanceTo(pos);
    	
    	//System.out.println(""+distanceToTarget);
    	this.addDebugCrosshair(latestSuccessfulScan.estimatedTargetPosition());
    	this.addDebugLine(this.getPosition(), latestSuccessfulScan.estimatedTargetPosition());
    	if (Math.abs(distanceToTarget)>30)
    	{
    		Angle n = scanDirection.add(new Angle ((aperture/2), "d"));
    		
    		this.addDebugArrow(this.getPosition(), new Vector(n, 50));
    		setAutopilot(n, 1.0);
    	}
    	else 
    	{    
    		Angle n = scanDirection.sub(new Angle (40, "d"));
    		this.addDebugArrow(this.getPosition(), new Vector(n, 50));
    		setAutopilot(n, 1.0);
    	}
    	
    }
    
    
    @Override
    protected void init() {
    	setNameColor(new Color((float)0.0,(float)0.0,(float)0.0));
        
    	scanAperture = new Angle(aperture, "d"); //getMaxScanAperture();
        scanDirection = getOrientation();
        setScanAperture(scanAperture);
        setScanDirection(scanDirection);
        latestSuccessfulScan = new Scan(
                RIGHT, 
                new Angle(360, "d"),
                Double.MAX_VALUE,
                this.getPosition(),
                Double.NEGATIVE_INFINITY);
        
    }



}
