import java.lang.Math;
import java.awt.Color;

import jrobots.simulation.simulationObjects.JRobot2010;
import jrobots.utils.*;

/**
 * Ein minimaler funktionierender Bot, fertig zur Programmierung.
 * <p>
 * Vielleicht sollte er einen neuen Namen bekommen, wenn er auf sich was halten
 * k&ouml;nnen soll.
 */
public class Streetveither extends JRobot2010 {

	private static final long serialVersionUID = 1L;
	private Angle scanRichtung, scanWinkel;
	private Scan letzterGuter, gutGemerkt;
	private double verloren, abgefeuert, gelegt;
	private int i, MIN_DIST, MAX_DIST;
	private boolean hoch, warGut, missileFired, bombeGelegt, rw;
	private double x, s;
	private Vector prediction, positionAlt;

	@Override
	protected void init() {
		setNameColor(new Color((float) 0.3, (float) 0.1, (float) 0.9));
		scanWinkel = new Angle(25, "d");
		scanRichtung = getOrientation();

		letzterGuter = null;
		i = 1;
		x = 0;
		hoch = true;
		warGut = false;
		verloren = 0;
		bombeGelegt = false;
		missileFired = false;
		prediction = null;
		s = 0;

		rw = false;
		gelegt = 0;
		abgefeuert = 0;
		this.setBodyColor(Color.GREEN);
		MIN_DIST = 6;
		MAX_DIST = 20;

	}

	@Override
	protected void actions() {
		calibrate();

		collect();
		
		scan();
		
			shoot();
		

		drive();
	}

	/**
	 * Vorbereitungen treffen
	 */
	private void calibrate() {
		// Garnix

	}

	/**
	 * Sensoren auswerten
	 */
	private void collect() {

	}

	/**
	 * Wohin soll der Scanner ausgerichtet werden?
	 */
	private void scan() {
		if (isScanFromNow()) {

			if (this.getLastScan().isTargetLocated()) {

				if (warGut) {

					scanWinkel = scanWinkel.mult(0.6); //0.8, 0.5

					if (scanWinkel.getValueAsDegrees() <= 1)
						scanWinkel = new Angle(2, "d");//2,5

					scanRichtung = scanRichtung.sub(new Angle(5, "d")); //5 sub

					letzterGuter = this.getLastScan();

				} else {
					warGut = true;
					gutGemerkt = this.getLastScan();

					letzterGuter = gutGemerkt;

				}

			} else {

				if (warGut) {
					scanWinkel = new Angle(20, "d");
					scanRichtung = scanRichtung.add(new Angle(10, "d")); //5 add, 7
					letzterGuter = gutGemerkt;

					if (verloren == -1)
						verloren = this.getTime();

				}

				else {

					scanWinkel = new Angle(20, "d");
					scanRichtung = scanRichtung.add(new Angle(10, "d"));
					letzterGuter = gutGemerkt;

				}
				if (this.getTime() - verloren > 1) {
					warGut = false;
					verloren = -1;

				}

			}

		}

		setScanAperture(scanWinkel);
		setScanDirection(scanRichtung);
	}

	private double time = 0;
	

	private void reset() {
		time = this.getTime() + 2;
	}

	/**
	 * Wohin soll geschossen werden?
	 */
	private void shoot() {
		double now = getTime();
		
		if (gutGemerkt == null || letzterGuter == null) {
			return;
		}
		double dtt = letzterGuter.distanceToTarget;
		
		if (now - time > 1.5) { //andersrum
			reset();
		}

		prediction = LinearPredictor.predict(gutGemerkt, letzterGuter, time);
		addDebugCrosshair(prediction);
		s = this.getPosition().distanceTo(prediction);

		// Minen, Lenkrekete, Falle

		missileFired = launchMissile();
		
		if (!missileFired) {
			boolean bombeLegen = now - gelegt >= getMineReloadTime() + 2;

			setMissileTarget(prediction.add(new Vector(5,0)));

			if (dtt > 10) {
				if (!bombeLegen && rw) {
					bombeGelegt = plantBomb();
				}
				shootProjectile();
			}

			if (dtt <= 25) {
				shootBullet();
			}

			if (dtt < 6 && !bombeGelegt) {
				bombeGelegt = dropTrap();
			}
		}
		
		System.out.println(String.format("MF: %b BG: %b RW: %b Zeiten: Now: %f Time: %f AF: %f BG: %f Distanz: %f",
				missileFired, bombeGelegt, rw, now, time, abgefeuert, gelegt, dtt));
	}

	private boolean launchMissile() {
		if (getTime() - abgefeuert >= getMissileReloadTime() + 6) {
			setLaunchMissileCommand(prediction.sub(getPosition()).getAngle());
			abgefeuert = getTime();
			System.out.println("Lenkrakete");
			return true;
		} else
			return false;
	}

	private boolean shootProjectile() {
		addDebugArrow(getPosition(), prediction);
		double t = s / getProjectileSpeed();
		boolean shootBullet = time - getTime() + 0.2 >= t;
		if (shootBullet) {
			setLaunchProjectileCommand(prediction.sub(getPosition()).getAngle()
					.add(new Angle(3.5, "d")));//5
			System.out.println("Projectile");
		}
		return shootBullet;
	}

	private boolean dropTrap() {
		setDropTankTrapCommand(true);
		System.out.println("Falle");
		gelegt = this.getTime();

		return true;
	}

	private boolean shootBullet() {
		double t = s / getBulletSpeed();
		if (time - getTime() + 0.5 >= t) {
			setLaunchBulletCommand(prediction.sub(getPosition()).getAngle()
					.add(new Angle(6, "d"))); //5
			System.out.println("Bullet");

		}

		return true;
	}

	private boolean plantBomb() {
		if (getTime() - gelegt > this.getMineReloadTime())
			return false;

		setDropMineCommand(true);
		gelegt = this.getTime();
		System.out.println("Mine");
		return true;
	}

	/**
	 * Wohin f??hrt der JRobot?
	 */
	private void drive() {

		

		if (letzterGuter != null) {
			boolean weg = letzterGuter.distanceToTarget <= MIN_DIST;
			boolean hin = letzterGuter.distanceToTarget >= MAX_DIST;
			if (this.getPosition() == positionAlt || weg) {
				rw = true;
				setAutopilot(letzterGuter.scanDirection.getOpposite(),
						Math.random() + 0.15);

			} else {

				rw = false;
								setAutopilot(prediction.sub(getPosition()).getAngle(),
							1);

			}
		}
		positionAlt = this.getPosition();
	}

}
